# coding: utf-8
import sys
from tkinter import *
from imagecanvas import *

#■定義外値の調整(以下のような目的に用いる）
#
#  (1) フィルタによっては値が負になることがあるので調整。
#  (2) 画像範囲外のとき、みなし値を決める際の配列添え字。
#
def rangeMax(x, MAX):
    if x<0:
        return 0
    elif x>MAX:
        return MAX
    return x

#■フィルタ処理
def procFilter(Filter, knum, addR, addG, addB):
    NX=len(cbit.ID)
    NY=len(cbit.ID[0])
    DX=int(NX/20)   # "フィルタ処理中"を表示する間隔
    K=1
    for x in range(NX):
        if (x % DX)==0:
            root.title("フィルタ処理中"+"■"*K)
            K+=1
        for y in range(NY):
            R=0  # １画素のフィルタ処理0
            G=0
            B=0
            for k1 in range(knum):
                xx=x+k1-1
                xx=rangeMax(xx, NX-1)
                for k2 in range(knum):
                    yy=y+k2-1
                    yy=rangeMax(yy, NY-1)
                    R+=tmp[xx][yy][0]*Filter[k1][k2]
                    G+=tmp[xx][yy][1]*Filter[k1][k2]
                    B+=tmp[xx][yy][2]*Filter[k1][k2]
            R=rangeMax(int(R+addR),255)
            G=rangeMax(int(G+addG),255)
            B=rangeMax(int(B+addB),255)
            cbit.Canvas.itemconfig(cbit.ID[x][y],fill=RGB(R,G,B))
    root.update()
    root.title("フィルタ処理完了")
    
#■平滑化フィルタ
def shadeOff():
    procFilter([[ 1/9, 1/9, 1/9],
                [ 1/9, 1/9, 1/9],
                [ 1/9, 1/9, 1/9]], 3, 0,0,0)
    
#■加重平均フィルタ
def average():
    procFilter([[ 1/16, 2/16, 1/16],
                [ 2/16, 4/16, 2/16],
                [ 1/16, 2/16, 1/16]], 3, 0,0,0)
    
#■鮮明化フィルタ
def distinct():
    procFilter([[ 0, -1,  0],
                [-1,  5, -1],
                [ 0, -1,  0]], 3, 0,0,0)
    
#■エッジ抽出フィルタ
def detectEdge():
    procFilter([[ 1,  0],
                [ 0, -1]],  2, 0,0,0)
#    以下は輪郭が若干太くなります。
#    procFilter([[-1, 0, 1],
#                [-2, 0, 2],
#                [-1, 0, 1]], 3, 0,0,0)
#    procFilter([[-1, 0, 1],
#                [-1, 0, 1],
#                [-1, 0, 1]], 3, 0,0,0)

#■エンボス効果フィルタ
def emboss():
    procFilter([[ 1,  0],
                [ 0, -1]], 2, 100, 100, 100)
#    加算する値によって色調が変わります。以下は全体が赤っぽくなります
#    procFilter([[ 1,  0],
#                [ 0, -1]], 2, 100, 0, 0)

#■ウィンドウが閉じられるときの処理
def exitProc():
    if messagebox.askokcancel("終了","終了してもよろしいですか?"):
        root.destroy()
        sys.exit()
#■メイン処理   
root = Tk()
root.geometry("600x500")
root.title("フィルタ処理")
FT=[('BMPファイルlファイル','*.bmp;*.*')]
filename=filedialog.askopenfilename(filetypes=FT)
if filename!="":
    root.title("ビットマップ読込み中")
    bitmap=readBitmap(filename)
    if bitmap!=[]:
        #準備処理
        root.title("キャンバス準備中")
        canvas=Canvas(root,width=bitmap.info.width,height=bitmap.info.height)
        canvas.place(x=0,y=30)
        canvas2=Canvas(root,width=bitmap.info.width,height=bitmap.info.height)
        canvas2.place(x=bitmap.info.width,y=30)
        root.title("ビットマップ表示中")
        cbit=drawBitmap(canvas, bitmap)
        root.update()
        root.title("元画像ビットマップ表示中")
        c2=drawBitmap(canvas2, bitmap)
        root.update()
        root.title("ビットマップリスト準備中")
        tmp=getRGBList(cbit)
        root.title("フィルタ処理")
        #ラベルの宣言
        label1 = Label(root, text='処理後', fg='black')
        label1.place(x=10, y=2)
        label2 = Label(root, text='元画像', fg='black')
        label2.place(x=bitmap.info.width+10, y=2)
        #ボタンの宣言                        
        button1 = Button(root, text='終了', command=exitProc)
        button1.place(x=400, y=400)
        button2 = Button(root, text='平滑化', command=shadeOff)
        button2.place(x=10, y=400)
        button3 = Button(root, text='加重平均', command=average)
        button3.place(x=60, y=400)
        button4 = Button(root, text='鮮明化', command=distinct)
        button4.place(x=120, y=400)
        button5 = Button(root, text='エッジ抽出', command=detectEdge)
        button5.place(x=170, y=400)
        button5 = Button(root, text='エンボス効果', command=emboss)
        button5.place(x=245, y=400)
        #メインループ("WM_DELETE_WINDOW"が届いたときexitProcを呼び出す)
        root.protocol("WM_DELETE_WINDOW",exitProc)
        root.mainloop()
root.destroy()
sys.exit()
        
